/*
 * DescriptionDialog.java
 *
 * Created on 11 March 2003, 23:16
 */

package com.togethersoft.modules.p4vcs.dialogs;

import com.perforce.api.Change;
import com.perforce.api.Env;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTextArea;
import javax.swing.border.BevelBorder;
import javax.swing.border.EmptyBorder;
import javax.swing.JMenuBar;
import javax.swing.JMenu;

/** @author  Administrator */
public class ChangeDescriptionDialog extends JDialog
{

   /** Creates new form DescriptionDialog */
   public ChangeDescriptionDialog(JDialog parent, boolean modal, Change change, Env env)
   {
      super(parent, "Perforce Changelist Description", modal);
      this.env = env;
      this.change = change;
      showingDiff = false;
      initComponents();
      syncChange("-s", hideDiffs, hideDiffsMenuItem);
      textArea.setText(change.getDescription());
   }

   /**
    * This method is called from within the constructor to initialize the form.
    * WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form Editor.
    */
   private void initComponents()
   { //GEN-BEGIN:initComponents

      describeClientMenuItem = new JMenuItem();
      describeUserMenuItem = new JMenuItem();
      selectAllMenuItem = new JMenuItem();
      copyMenuItem = new JMenuItem();
      hideDiffsMenuItem = new JMenuItem();
      rcsMenuItem = new JMenuItem();
      contextMenuItem = new JMenuItem();
      unifiedMenuItem = new JMenuItem();
      summaryMenuItem = new JMenuItem();
      normalMenuItem = new JMenuItem();
      closeMenuItem = new JMenuItem();
      diffMenu = new JMenu();
      describeMenu = new JMenu();
      editMenu = new JMenu();
      fileMenu = new JMenu();
      menuBar = new JMenuBar();
      setJMenuBar(menuBar);
      diffPopupMenu = new JPopupMenu();
      normal = new JMenuItem();
      summary = new JMenuItem();
      unified = new JMenuItem();
      context = new JMenuItem();
      rcs = new JMenuItem();
      separator = new JSeparator();
      hideDiffs = new JMenuItem();
      textPanel = new JPanel();
      textArea = new JTextArea();      
      textScrollPane = new JScrollPane(textArea);
      buttonPanel = new JPanel();
      showDiffsButton = new JButton();
      closeButton = new JButton();

      diffPopupMenu.setFont(new Font("Dialog", 0, 11));
      normal.setFont(new Font("Dialog", 0, 11));
      normal.setText("Normal");
      diffPopupMenu.add(normal);
      summary.setFont(new Font("Dialog", 0, 11));
      summary.setText("Summary");
      diffPopupMenu.add(summary);
      unified.setFont(new Font("Dialog", 0, 11));
      unified.setText("Unified");
      diffPopupMenu.add(unified);
      context.setFont(new Font("Dialog", 0, 11));
      context.setText("Context");
      diffPopupMenu.add(context);
      rcs.setFont(new Font("Dialog", 0, 11));
      rcs.setText("RCS");
      diffPopupMenu.add(rcs);
      diffPopupMenu.add(separator);
      hideDiffs.setFont(new Font("Dialog", 0, 11));
      hideDiffs.setText("Hide Diffs");
      diffPopupMenu.add(hideDiffs);

      addWindowListener(
          new WindowAdapter()
          {
             public void windowClosing(WindowEvent evt)
             {
                closeDialog(evt);
             }
          });

      textPanel.setLayout(new BoxLayout(textPanel, BoxLayout.X_AXIS));
      textPanel.setPreferredSize(new Dimension(900, 400));
      textPanel.setBorder(new EmptyBorder(new Insets(3, 3, 3, 3)));        
      textPanel.add(textScrollPane);

      textArea.setBackground(new Color(212, 208, 200));
      textArea.setBorder(new BevelBorder(BevelBorder.LOWERED));
      textArea.setEditable(false);

      getContentPane().add(textPanel, BorderLayout.CENTER);

      buttonPanel.setLayout(new FlowLayout(FlowLayout.RIGHT));

      showDiffsButton.setFont(new Font("Dialog", 0, 11));
      showDiffsButton.setText("Show Diffs");
      showDiffsButton.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent evt)
             {
                showDiffsButtonActionPerformed(evt);
             }
          });

      buttonPanel.add(showDiffsButton);

      closeButton.setFont(new Font("Dialog", 0, 11));
      closeButton.setText("Close");
      closeButton.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent evt)
             {
                closeButtonActionPerformed(evt);
             }
          });

      buttonPanel.add(closeButton);

      getContentPane().add(buttonPanel, BorderLayout.SOUTH);

      normal.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent e) { normalActionPerformed(e); }
          });
      summary.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent e) { summaryActionPerformed(e); }
          });
      unified.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent e) { unifiedActionPerformed(e); }
          });
      context.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent e) { contextActionPerformed(e); }
          });
      rcs.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent e) { rcsActionPerformed(e); }
          });
      hideDiffs.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent e) { hideDiffsActionPerformed(e); }
          });


      fileMenu.setText("File");
      fileMenu.add(closeMenuItem);
      menuBar.add(fileMenu);
      menuBar.add(editMenu);
      menuBar.add(describeMenu);
      menuBar.add(diffMenu);
      editMenu.setText("Edit");
      editMenu.add(copyMenuItem);
      editMenu.add(selectAllMenuItem);
      describeMenu.setText("Describe");
      describeMenu.add(describeUserMenuItem);
      describeMenu.add(describeClientMenuItem);
      diffMenu.setText("Diff");
      diffMenu.add(normalMenuItem);
      diffMenu.add(summaryMenuItem);
      diffMenu.add(unifiedMenuItem);
      diffMenu.add(contextMenuItem);
      diffMenu.add(rcsMenuItem);
      diffMenu.addSeparator();
      diffMenu.add(hideDiffsMenuItem);
      closeMenuItem.setText("Close");
      normalMenuItem.setText("Normal");
      summaryMenuItem.setText("Summary");
      unifiedMenuItem.setText("Unified");
      contextMenuItem.setText("Context");
      rcsMenuItem.setText("RCS");
      hideDiffsMenuItem.setText("Hide Diffs");
      closeMenuItem.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){closeMenuItemActionPerformed(e);}});
      normalMenuItem.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){normalActionPerformed(e);}});
      summaryMenuItem.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){summaryActionPerformed(e);}});
      unifiedMenuItem.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){unifiedActionPerformed(e);}});
      contextMenuItem.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){contextActionPerformed(e);}});
      rcsMenuItem.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){rcsActionPerformed(e);}});
      hideDiffsMenuItem.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){hideDiffsActionPerformed(e);}});

      pack();
      Dimension dimension = getContentPane().getSize();
      Dimension dimension1 = Toolkit.getDefaultToolkit().getScreenSize();
      setLocation((dimension1.width - dimension.width) / 2, (dimension1.height - dimension.height) / 2);
      copyMenuItem.setText("Copy");
      selectAllMenuItem.setText("Select All");
      selectAllMenuItem.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){selectAllMenuItemActionPerformed(e);}});
      copyMenuItem.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){copyMenuItemActionPerformed(e);}});
      describeUserMenuItem.setText("Describe User");
      describeClientMenuItem.setText("Describe Client");
      describeUserMenuItem.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){describeUserMenuItemActionPerformed(e);}});
      describeClientMenuItem.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){describeClientMenuItemActionPerformed(e);}});
   } //GEN-END:initComponents

   private void showDiffsButtonActionPerformed(ActionEvent evt)
   { //GEN-FIRST:event_showDiffsButtonActionPerformed
      if (showingDiff)
      {
         diffPopupMenu.show(showDiffsButton, 5, 5);
      }
      else
      {
         syncChange("", normal, normalMenuItem);
         showingDiff = true;
      }

   } //GEN-LAST:event_showDiffsButtonActionPerformed

   private void syncChange(String options, JMenuItem menuItem, JMenuItem menuItem1)
   {
      enableMenus();
      menuItem.setEnabled(false);
      menuItem1.setEnabled(false);
      change.sync(change.getNumber(), options, false);
      textArea.setText(change.getDescription());
   }

   private void enableMenus()
   {
      normal.setEnabled(true);
      summary.setEnabled(true);
      unified.setEnabled(true);
      context.setEnabled(true);
      rcs.setEnabled(true);
      normalMenuItem.setEnabled(true);
      summaryMenuItem.setEnabled(true);
      unifiedMenuItem.setEnabled(true);
      contextMenuItem.setEnabled(true);
      rcsMenuItem.setEnabled(true);
      hideDiffs.setEnabled(true);
      hideDiffsMenuItem.setEnabled(true);
   }

   private void closeButtonActionPerformed(ActionEvent evt)
   { //GEN-FIRST:event_closeButtonActionPerformed
      closeDialog(null);
   } //GEN-LAST:event_closeButtonActionPerformed

   /** Closes the dialog */
   private void closeDialog(WindowEvent evt)
   { //GEN-FIRST:event_closeDialog
      setVisible(false);
      dispose();
   } //GEN-LAST:event_closeDialog


   public void normalActionPerformed(ActionEvent e) { showingDiff = true; syncChange("", normal, normalMenuItem); }

   public void summaryActionPerformed(ActionEvent e) { showingDiff = true; syncChange("-ds", summary, summaryMenuItem); }

   public void unifiedActionPerformed(ActionEvent e) { showingDiff = true; syncChange("-du", unified, unifiedMenuItem); }

   public void contextActionPerformed(ActionEvent e) { showingDiff = true; syncChange("-dc", context, contextMenuItem); }

   public void rcsActionPerformed(ActionEvent e) { showingDiff = true; syncChange("-dn", rcs, rcsMenuItem); }

   public void hideDiffsActionPerformed(ActionEvent e)
   {
      syncChange("-s", hideDiffs, hideDiffsMenuItem);
      showingDiff = false;
   }

   public void closeMenuItemActionPerformed(ActionEvent e) { closeDialog(null); }

   public void selectAllMenuItemActionPerformed(ActionEvent e) { textArea.selectAll(); }

   public void copyMenuItemActionPerformed(ActionEvent e) { textArea.copy(); }

   public void describeUserMenuItemActionPerformed(ActionEvent e) { }

   public void describeClientMenuItemActionPerformed(ActionEvent e) { }

   // Variables declaration - do not modify//GEN-BEGIN:variables
   private JPopupMenu diffPopupMenu;
   private JMenuItem normal;
   private JMenuItem summary;
   private JMenuItem unified;
   private JMenuItem context;
   private JMenuItem rcs;
   private JSeparator separator;
   private JMenuItem hideDiffs;
   private JPanel textPanel;
   private JScrollPane textScrollPane;
   private JTextArea textArea;
   private JPanel buttonPanel;
   private JButton showDiffsButton;
   private JButton closeButton;
   // End of variables declaration//GEN-END:variables

   private Env env;
   private Change change;
   private boolean showingDiff;
   private JMenuBar menuBar;
   private JMenu fileMenu;
   private JMenu editMenu;
   private JMenu describeMenu;
   private JMenu diffMenu;
   private JMenuItem closeMenuItem;
   private JMenuItem normalMenuItem;
   private JMenuItem summaryMenuItem;
   private JMenuItem unifiedMenuItem;
   private JMenuItem contextMenuItem;
   private JMenuItem rcsMenuItem;
   private JMenuItem hideDiffsMenuItem;
   private JMenuItem copyMenuItem;
   private JMenuItem selectAllMenuItem;
   private JMenuItem describeUserMenuItem;
   private JMenuItem describeClientMenuItem;
}
